import { ICustomElement, provide } from 'component-register';

type StoreContext = {
    animationQueue: Promise<unknown>[];
};
type CreateContextOptions = {
    root: HTMLElement & ICustomElement;
    isOpen: boolean;
    isAnimating: boolean;
};
type WalkableNode = Parameters<typeof provide>[2];
export declare const provideDrawerContext: (initialState: Omit<CreateContextOptions, "root">, element: WalkableNode) => readonly [{
    animationQueue: Promise<unknown>[];
    isOpen: boolean;
    isAnimating: boolean;
}, {
    readonly setElementState: (key: keyof Omit<CreateContextOptions, "root">, value: boolean | ((v: boolean) => boolean)) => void;
    readonly setStore: import('solid-js/store').SetStoreFunction<StoreContext>;
}];
export declare const useDrawerContext: (context: readonly [{
    animationQueue: Promise<unknown>[];
    isOpen: boolean;
    isAnimating: boolean;
}, {
    readonly setElementState: (key: keyof Omit<CreateContextOptions, "root">, value: boolean | ((v: boolean) => boolean)) => void;
    readonly setStore: import('solid-js/store').SetStoreFunction<StoreContext>;
}]) => readonly [{
    animationQueue: Promise<unknown>[];
    isOpen: boolean;
    isAnimating: boolean;
}, {
    readonly updateAnimationQueue: (animation: Promise<unknown>) => void;
    readonly close: () => void;
    readonly open: () => void;
    readonly toggle: () => void;
}];
export declare const useDrawer: (element: HTMLElement & ICustomElement) => readonly [{
    animationQueue: Promise<unknown>[];
    isOpen: boolean;
    isAnimating: boolean;
}, {
    readonly updateAnimationQueue: (animation: Promise<unknown>) => void;
    readonly close: () => void;
    readonly open: () => void;
    readonly toggle: () => void;
}];
export declare const getDrawerContext: (element: Element) => readonly [{
    animationQueue: Promise<unknown>[];
    isOpen: boolean;
    isAnimating: boolean;
}, {
    readonly updateAnimationQueue: (animation: Promise<unknown>) => void;
    readonly close: () => void;
    readonly open: () => void;
    readonly toggle: () => void;
}];
export {};
