import { Easing } from 'motion';
import { Position } from './consts.js';

export declare function hideElement<T extends HTMLElement>(element: T): void;
export declare function showElement<T extends HTMLElement>(element: T): void;
export declare function getTransitionConfig<T extends HTMLElement>(element: T): {
    duration: number;
    delay: number;
    endDelay: number;
    easing: Easing;
    direction: PlaybackDirection;
    repeat: number;
    allowWebkitAcceleration: boolean;
};
export declare function getSpringConfig<T extends HTMLElement>(element: T): {
    position: Position;
    easing: {
        damping: number;
        velocity: number;
        stiffness: number;
        mass: number;
        restSpeed: number;
        restDistance: number;
    };
    duration: number;
    delay: number;
    endDelay: number;
    direction: PlaybackDirection;
    repeat: number;
    allowWebkitAcceleration: boolean;
};
export declare function convertPositionToTranslate(position: Position): string[];
