import { SetParams } from '@solidjs/router';

export type MatchFilter = readonly string[] | RegExp | ((s: string) => boolean);
export type MatchFilters<P extends string | readonly string[] = any> = P extends string ? {
    [K in PathParams<P>[number]]?: MatchFilter;
} : Record<string, MatchFilter>;
export type PathParams<P extends string | readonly string[]> = P extends `${infer Head}/${infer Tail}` ? [...PathParams<Head>, ...PathParams<Tail>] : P extends `:${infer S}?` ? [S] : P extends `:${infer S}` ? [S] : P extends `*${infer S}` ? [S] : [];
export type Params = Record<string, string>;
export interface PathMatch {
    params: Params;
    path: string;
}
export declare function createMatcher<S extends string>(path: S, partial?: boolean, matchFilters?: MatchFilters<S>): (location: string) => PathMatch | null;
export declare function expandOptionals(pattern: string): string[];
export declare function getRouteTemplates(children: HTMLCollection): HTMLTemplateElement[];
export declare function cloneElement(element: HTMLElement | HTMLTemplateElement | Element): HTMLElement;
export declare function mergeSearchString(search: string, params: SetParams): string;
