import { createRouter, MatchFilters, NavigateOptions, Params, SetParams } from '@solidjs/router';
import { ICustomElement } from 'component-register';

type RouterContext = Parameters<NonNullable<Parameters<typeof createRouter>[0]["create"]>>[0];
export declare const getHashRouterContextId: () => symbol;
export declare const provideRouterContext: (router: RouterContext, element: HTMLElement) => any;
export declare const useNavigate: (element: ICustomElement & HTMLElement) => import('@solidjs/router').Navigator;
export declare const useParams: <T extends Params>(element: ICustomElement & HTMLElement) => T;
export declare const useLocation: (element: ICustomElement & HTMLElement) => import('@solidjs/router').Location<unknown>;
export declare const useSearchParams: <T extends Params>(element: ICustomElement & HTMLElement) => (Partial<T> | ((params: SetParams, options?: Partial<NavigateOptions>) => void))[];
export declare const useIsRouting: (element: ICustomElement & HTMLElement) => () => boolean;
export declare const useMatch: <S extends string>(element: ICustomElement & HTMLElement, path: () => S, matchFilters?: MatchFilters<S>) => import('solid-js').Accessor<import('../utils.js').PathMatch | undefined>;
export declare const useCurrentMatches: (element: HTMLElement & ICustomElement) => () => import('@solidjs/router').RouteMatch[];
export {};
