import { ICustomElement, provide } from 'component-register';

type CreateContextOptions = {
    root: HTMLElement & ICustomElement;
    activeTab: string;
};
type WalkableNode = Parameters<typeof provide>[2];
type ContextKey = keyof Omit<CreateContextOptions, "root">;
type ContextValue<K extends ContextKey> = Omit<CreateContextOptions, "root">[K];
type ContextCallback<K extends ContextKey, T = ContextValue<K>> = (state: T) => T extends infer R extends ContextValue<K> ? R : never;
export declare const provideTabItemsContext: (initialState: Omit<CreateContextOptions, "root">, element: WalkableNode) => readonly [{
    activeTab: string;
}, {
    readonly setElementState: <K extends "activeTab", T extends ContextValue<K>>(key: ContextKey, value: T | ContextCallback<K>) => void;
}];
export declare const useTabItemsContext: (context: readonly [{
    activeTab: string;
}, {
    readonly setElementState: <K extends "activeTab", T extends ContextValue<K>>(key: ContextKey, value: T | ContextCallback<K>) => void;
}]) => readonly [{
    activeTab: string;
}, {
    readonly tab: {
        readonly activate: (id: string) => void;
        readonly isActive: (key: string) => boolean;
    };
}];
export declare const useTabItems: (element: HTMLElement & ICustomElement) => readonly [{
    activeTab: string;
}, {
    readonly tab: {
        readonly activate: (id: string) => void;
        readonly isActive: (key: string) => boolean;
    };
}];
export declare const getTabItemsContext: (element: Element) => readonly [{
    activeTab: string;
}, {
    readonly tab: {
        readonly activate: (id: string) => void;
        readonly isActive: (key: string) => boolean;
    };
}];
export {};
