import { ComponentType as mComponentType, ICustomElement, PropsDefinitionInput } from 'component-register';

export type ComponentType<T> = mComponentType<T>;
type CorrectComponentOptions = {
    element: HTMLElement & ICustomElement;
};
export type CorrectComponentType<T> = (props: T, options: CorrectComponentOptions) => unknown;
declare function customElement<T extends object>(tag: string, ComponentType: ComponentType<T>): (ComponentType: ComponentType<T>) => any;
declare function customElement<T extends object>(tag: string, props: PropsDefinitionInput<T>, ComponentType: ComponentType<T>): (ComponentType: ComponentType<T>) => any;
declare function customShadowlessElement<T extends object>(tagName: string, props: T, Component?: ComponentType<T>, ...rest: ((C: ComponentType<T>) => ComponentType<T>)[]): import('component-register/types/utils').ComponentType<any>;
declare const correctElementType: <T>(component: CorrectComponentType<T>) => ComponentType<T>;
export { customElement, customShadowlessElement, correctElementType };
